xquery version "3.1";
(:~
 : Provides the endpoint for SADE Publish process
 : Entrypoint for index and overview creation.
 :)

import module namespace tgconnect="https://sade.textgrid.de/ns/connect" at "../modules/textgrid/connect.xqm";
import module namespace config="https://sade.textgrid.de/ns/config" at "../modules/config.xqm";
import module namespace index-creation="http://bdn-edition.de/ns/index-creation" at "../modules/bdn/index-creation.xqm";
import module namespace internal-nav="http://bdn-edition.de/ns/internal-nav" at "../modules/bdn/internal-nav.xqm";

let $uri as xs:string := request:get-parameter("uri", ""),
    $sid as xs:string := request:get-parameter("sid", ""),
    $target as xs:string := request:get-parameter("target", "data"),
    $user as xs:string := request:get-parameter("user", ""),
    $password as xs:string := request:get-parameter("password", ""),
    $project as xs:string := request:get-parameter("project", ""),
    $surface as xs:string := request:get-parameter("sf", ""),
    $login as xs:boolean := false(),
    $operation as xs:string := request:get-parameter("operation", "")



(: catching this error does not work properly due to a wrong implementation in exist-db but it still does return false() on failed log-in:)
let $isLoggedIn := try {
    xmldb:login($config:data-root , $user, $password)
  } catch * {
    false()
  }

return
  if ($isLoggedIn)
  then
    if ($operation = "") then
			<div>{
				for $i in tgconnect:publish($uri,$sid,$target,$user,$password,$project,$surface,$login)
				return
						<ok>{ $uri } » { $i }</ok>
			}</div>
    else if($operation = "overview") then
      <div>
        <ok>Overview saved to » {internal-nav:main()}</ok>
      </div>
    else if($operation = "indices") then
      <div>
        <ok>Created all index files. {index-creation:main()}</ok>
      </div>
    else
      error(QName("http://bdn-edition.de/ns/error", "OPERATION01"), "unknown operation: " || $operation)
  else
    error(
      QName("https://sade.textgrid.de/ns/error", "PUBLISH02"),
      "error authenticating for " || $user || " on " || $operation
    )
